/* src/chaninfo.c - Lire les informations  propos d'un salon
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "main.h"

CVSINFO("$Id: chaninfo.c,v 1.28 2003/07/31 10:50:42 kouak Exp $");

/*
 * chaninfo
 *
 * parv[1] = #salon
 */
extern int whoison(aNick *nick, aChan *chaninfo, int parc, char **parv);

int chaninfo(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp = chaninfo->access;
	char options[300] = {0}, *p;

	if((chaninfo->mode & (C_MSECRET | C_MPRIVATE)) /* salon +s ou +p */
		&& (!nick->user || !GetAccessIbyUserI(nick->user, chaninfo->chan))	/* non logu ou n'a pas d'accs */
		&& !IsAnAdmin(nick->user) && !getjoininfo(nick, chaninfo->chan)) /* ET ni admin, ni prsent */
			return csntc(nick, "Vous ne pouvez pas voir le chaninfo de %s.", chaninfo->chan);

	for(;lp && lp->value.a->level != OWNERLEVEL;lp=lp->next);/* recherche de l'owner*/

	csntc(nick, "------------------[ \0032\2%s\2\0036 > Informations\3         ]------------------", parv[1]);
	csntc(nick, "\2Fondateur     :\2 %s", lp ? lp->value.a->user->nick : "Aucun");
	csntc(nick, "\2Description   :\2 %s", chaninfo->description);

	if(IsAnAdmin(nick->user) || !strchr(chaninfo->defmodes, 'k') || getjoininfo(nick, chaninfo->chan))
		csntc(nick, "\2Defmodes      :\2 %s", chaninfo->defmodes);

	csntc(nick, "\2Deftopic      :\2 %s", chaninfo->deftopic);
	if(IsAnAdmin(nick->user)) csntc(nick, "\2Motd          :\2 %s", NONE(chaninfo->motd));
	if(IsAnAdmin(nick->user) && CWantUnreg(chaninfo)) csntc(nick, "\2Salon en procdure d'Unreg\2");
	csntc(nick, "\2Url du salon  :\2 %s", chaninfo->url);

	if(CLockTopic(chaninfo)) strcat(options, " locktopic");
	if(CNoOps(chaninfo)) strcat(options, " noops");
	if(CNoBans(chaninfo)) strcat(options, " nobans");
	if(CStrictOp(chaninfo)) strcat(options, " strictop");
	if(CSetWelcome(chaninfo)) strcat(options, " welcome");
	if(CAutoInvite(chaninfo)) strcat(options, " autoinvite");
	if(CFLimit(chaninfo)) strcat(options, " auto-limit");
	if(IsAnAdmin(nick->user) && (chaninfo->flag & C_ALREADYRENAME)) strcat(options, " renomm");

	csntc(nick, "\2Options       :\2%s", options[0] != '\0' ? options : " Aucunes");
	csntc(nick, "\2Banlevel      :\2 %3d    \2Bantype       :\2 %s", chaninfo->banlevel, GetBanType(chaninfo));

	csntc(nick, "\2ChModesLevel  :\2 %3d    \2Bantime       :\2 %s", chaninfo->cml,
			chaninfo->bantime ? duration(chaninfo->bantime) : "Aucun");

	if(CSetWelcome(chaninfo)) csntc(nick, "\2Welcome       :\2 %s", chaninfo->welcome);
	if(IsAnAdmin(nick->user)) show_suspend(nick, chaninfo);
	csntc(nick, "\2Topic actuel  :\2 %s", chaninfo->topic);

	p = GetCModes(chaninfo);
	csntc(nick, "\2Modes actuels :\2 %s%s %s", *p ? "+" : "Aucun", p,
		(*p && (chaninfo->mode & C_MKEY)) ? (IsAnAdmin(nick->user) ? chaninfo->key : "****") : "");

	if(IsAnAdmin(nick->user)) whoison(nick, chaninfo, parc, parv);
	csntc(nick, "-");
	strcpy(options, RealCmd("banlist"));
	csntc(nick, "Utilisez la commande \2%s\2 pour voir les bans, et la commande \2%s\2 pour la liste des accs au salon.",
		options, RealCmd("access"));

	return 1;
}
