/* src/nickserv.c - Diverses commandes sur le module nickserv
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "nickserv.h"

CVSINFO("$Id: nickserv.c,v 1.102 2003/08/06 08:34:52 romexzf Exp $");

#ifdef USE_WELCOMESERV
char user_motd[400];
char admin_motd[400];
#endif

void cswall(const char *msg, ...)
{
	register aNick *n = nickhead;
	char buf[512];

	va_list vl;
	va_start(vl, msg);
	vsnprintf(buf, sizeof buf, msg, vl);
	va_end(vl);

	for(;n;n = n->next) if(IsAnAdmin(n->user)) csntc(n, "%s", buf);
	return;
}

int register_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user = NULL;
	char p[20]
#ifdef USE_MEMOSERV
, memo[MEMOLEN + 1]
#endif
;
	time_t current = time(NULL);

	if(nick->user
#ifdef ADMINREG
		&& !IsAnAdmin(nick->user)
#endif
	) return csntc(nick, "Vous tes dj identifi sous l'username \2%s\2, et vous ne pouvez avoir plus d'un username.", nick->user);

	if(NRegister(nick) && !nick->user) /* on check a avant tout parce que a sert  rien de faire les verifs sinon*/
		return csntc(nick, "Vous avez dja utilis la commande register.");

	if(!strcasecmp(mailprog, "nomail") || nick->user || premiere)
	{
		if(parc < 3)
			return csntc(nick, "Veuillez spcifier un mot de passe.");

		if(strlen(parv[3]) < 6 || strlen(parv[3]) > 15)
			return csntc(nick, "Le pass doit faire entre 6 et 15 caractres.");

		strcpy(p, parv[3]);
	}
	else Strncpy(p, mkpass(nickhead->host), sizeof p -1);

	if(!IsValidNick(parv[1]))
		return csntc(nick, "%s ne peut pas tre enregistr, il contient des caractres illgaux.", parv[1]);

	if(IsBadNick(parv[1]))
		return csntc(nick, "%s ne peut pas tre enregistr: pseudo illgal.", parv[1]);

	if(!nick->user && strcasecmp(nick->nick, parv[1]) && getnickbynick(parv[1])) /* le nick existe mais n'est pas le sien, risque d'abus*/
		return csntc(nick, "Ce pseudo est actuellement utilis mais ce n'est pas le votre, vous ne pouvez donc pas l'enregistrer.");

	if ((user = getuserinfo(parv[1])))
		return csntc(nick, "%s est dj un UserName enregistr. (Dernire visite il y a %s)", user->nick, duration(current - user->lastseend));

	if(strlen(parv[1]) > NICKLEN)
		return csntc(nick, "La longueur de l'UserName est limite  %d.", NICKLEN);

	if(strlen(parv[2]) > MAILLEN)
		return csntc(nick, "Le mail est limit  %d caractres.", MAILLEN);

	if(!IsValidMail(parv[2]))
		return csntc(nick, "Veuillez entrer un email correct.");

	for(user = userhead;user;user=user->next)
		if(!strcasecmp(user->mail, parv[2])) return csntc(nick, "Ce mail est dj utilis.");

	if(nick->user) user = add_regnick(parv[1], mkpass(p), current, 1, (U_POKACCESS | U_FIRST), parv[2], -1);
	else
	{
		SetNRegister(nick);
		user = add_regnick(parv[1], mkpass(p), current, premiere ? 4 : 1, !strcasecmp(mailprog, "nomail") ? U_POKACCESS : (U_POKACCESS | U_FIRST), parv[2], -1);
	}

#ifdef USE_MEMOSERV
	snprintf(memo, MEMOLEN, "Bienvenue sur les services CoderZ. Vous pouvez avoir la liste des commandes en tapant \2/%s %s", cs.nick, RealCmd("showcommands"));
	add_memo(user, "Services", current, memo, 0);
#endif

	append_file(USERS_FILE, user->nick);
	write_anuser(user);
	if(nick->user)
		return csntc(nick, "Username \2%s\2 enregistr (Mail: %s Pass: %s)", user->nick, user->mail, parv[3]);

	else if(!strcasecmp(mailprog, "nomail") || premiere)
	{
		nick->user = user;
		nick->user->n = nick;
#ifdef HAVE_VOTE
		nick->user->vote = -1;
#endif
		cs_account(nick, nick->user->nick);
		if(premiere)
		{
			chaninfo = add_chan(bot.chan, "Salon d'aide  propos des services CoderZ",
				"Salon d'aide  propos des services CoderZ", "+nt", "Salon d'aide  propos des services CoderZ",
				"Bienvenue sur le salon d'aide aux services CoderZ", "Vous pouvez aider nos users !", network);
			add_access(user, bot.chan, OWNERLEVEL, (A_OP | A_VOICE | A_PROTECT), time(NULL));
			csjoin(chaninfo);
			putlog(LOG_CHANS, "HELLO %s par %s (Salon d'aide  propos des services CoderZ)\n", bot.chan, nick->nick);
			write_chanlist();
			write_achan(chaninfo);
			write_anuser(user);
			csntc(nick, "Bienvenue sur les Services CoderZ " SPVERSION " !");
			csntc(nick, "Le salon %s vient d'tre enregistr sous votre Username", bot.chan);
			csntc(nick, "Vous avez bien enregistr l'UserName %s avec un access Administrateur de niveau maximum (\0024\2)", parv[1]);
			premiere = 0;
		}
		else csntc(nick, "Vous avez enregistr l'UserName %s avec le pass\2 %s\2 et le mail\2 %s\2.",parv[1], parv[3], parv[2]);
		csntc(nick, "\2Vous avez t identifi  TOUS les services");
		csntc(nick, "Lors de vos prochaines connexions vous pourrez vous identifier avec : \2/%s %s %s %s", cs.nick, RealCmd("login"), parv[1], parv[3]);
		csntc(nick, "Le mail (%s) que vous avez fourni peut tre utilis pour vous envoyer un pass en cas de problme.", parv[2]);
		csntc(nick, "Vous pouvez voir la liste des commandes avec \2/%s %s\2", cs.nick, RealCmd("showcommands"));
	}
	else
	{
		FILE *fm;
		char dir[150], mail[250];

		conv_char(user->nick, mail);
		snprintf(dir, sizeof dir, DBDIR "/%s.mail", mail);
		if(!(fm = fopen(dir, "w")))
			return csntc(nick, "Impossible d'envoyer le mail, votre pass est %s", p);

		fprintf(fm, "Subject: %s @ %s - Enregistrement UserName %s\n\n\n", cs.nick, network, user->nick);
		fprintf(fm, "Ceci est un email automatique du robot %s\n\nVotre mot de passe est : %s\n", cs.nick, p);
		fprintf(fm, "\nVeuillez le conserver.\nPour vous identifier tapez : /%s %s %s %s\n", cs.nick, RealCmd("login"), user->nick, p);
		fprintf(fm, "Si vous voulez le changer, tapez: /%s %s PASS <pass>\n\n\n%s, Services IRC CoderZ de %s\n", cs.nick, RealCmd("set"), cs.nick, network);
		fclose(fm);
		snprintf(mail, sizeof mail, "%s -f Services\\ de\\ %s %s < %s\n", mailprog, network, user->mail, dir);
		system(mail);
		remove(dir);

		csntc(nick, "Votre mot de passe a t envoy  \2%s\2", user->mail);
		csntc(nick, "Le compte sera supprim dans %s si vous ne vous loguez pas dessus", duration(REGISTER_TIMEOUT));
	}
	return 1;
}


/*
 * oubli_pass
 *
 * parv[1] = login
 * parv[2] = mail
 */
int oubli_pass(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	FILE *fm;
	anUser *user;
	char passwd[15], mail[250], dir[150];

	if(!strcasecmp(mailprog, "nomail"))
		return csntc(nick, "Commande desactive. Consultez un Administrateur.");

	if(nick->user)
		return csntc(nick, "Vous tes dj identifi sur un username");

	if(!(user = getuserinfo(parv[1]))) return csntc(nick, NOSUCHUSER, parv[1]);

	if(UOubli(user))
		return csntc(nick, "La commande %s a dj t utilise pour %s.", user->nick, RealCmd("oubli"));

	if(strcasecmp(user->mail, parv[2]))
		return csntc(nick, "Le mail de l'username %s n'est pas %s.", user->nick, parv[2]);

	SetNRegister(nick); /* si il se sert de oubli, c'est qu'il a deja un pseudo ! na ! */
	user->flag |= U_OUBLI;

	strncpy(passwd, mkpass(nickhead->host), 15);
	strcpy(user->passwd, mkpass(passwd));

	conv_char(user->nick, mail);
	snprintf(dir, sizeof dir, DBDIR "/%s.mail", mail);
	if(!(fm = fopen(dir, "w"))) return csntc(nick, "Impossible d'envoyer le mail.");

	fprintf(fm, "Subject: %s @ %s - Mot de passe oubli\n\nCher(e) %s\n\nVotre mot de passe sur %s est maintenant : %s\n", cs.nick, network, user->nick,cs.nick, passwd);
	fprintf(fm, "\nVeuillez le conserver.\nPour vous identifier tapez : /%s %s %s %s\n", cs.nick, RealCmd("login"), user->nick, passwd);
	fprintf(fm, "Si vous voulez le changer, tapez: /%s %s pass <pass>\n\n\n%s, Services IRC CoderZ de %s\n", cs.nick, RealCmd("set"), cs.nick, network);
	fclose(fm);
	snprintf(mail, sizeof mail, "%s -f Services\\ d'%s %s < %s\n", mailprog, network, user->mail, dir);
	system(mail);
	remove(dir);

	csntc(nick, "Le nouveau pass vient d'tre envoy par mail  %s.", parv[2]);
	write_anuser(user);
	return 1;
}


int drop_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anAccess *acces = nick->user->accesshead, *a2;

	if(parc < 2 || strcasecmp(parv[2], "confirme"))
		return csntc(nick, "Pour confirmer la suppression de votre Username, vous devez spcifier 'CONFIRME' comme dernier argument.");

	if(!checkpass(parv[1], nick->user))
		return csntc(nick, "\2Mot de pass incorrect.");

	csntc(nick, "Votre UserName (%s) a t supprim, ainsi que tous vos accs/mmos.", nick->user->nick);

	for(;acces;acces = a2)
	{
		a2 = acces->next;
		if(acces->level == OWNERLEVEL)
		{
			char tmp[400];
			snprintf(tmp, sizeof tmp, "Salon %s dsenregistr par le \2drop\2 de l'username de l'owner (\2%s\2)", acces->chan, nick->nick);
			del_chan(acces->c, tmp);
		}
	}
	del_regnick(nick->user);
	cs_account(nick, NULL);
	write_userlist();
	return 1;
}

int ns_login(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *user = NULL;
	anAccess *a;
	aJoin *j = NULL;
#ifdef HAVE_TRACK
	struct track *track;
#endif

	if(!(user = getuserinfo(parv[1]))) return csntc(nick, NOSUCHUSER, parv[1]);

	if(nick->user)
	{
		csntc(nick, "Vous tes dj identifi sous l'UserName \2%s\2.", nick->user->nick);
		if(IsAnAdmin(user) && user != nick->user)
		{
			cswall("Failed Login sur \2%s\2 par \2%s\2 (\2Admin %d\2)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d (dj logu) par %s@%s\n", user->nick, user->level, nick->nick, nick->user->nick);
		}
		return 0;
	}

	if(!checkpass(parv[2], user))
	{
		csntc(nick, "\2Mot de passe incorrect pour %s.\2", user->nick);
		csntc(nick, "Si vous ne vous en rappelez plus, utilisez : \2/%s %s %s <mail>", cs.nick, RealCmd("oubli"), user->nick);
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \2%s\2 par \2%s\2 (\2Admin %d\2)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d (bad password) par %s\n", user->nick, user->level, nick->nick);
		}
		return 0;
	}

	if(user->n && strcasecmp(parv[0], RealCmd("recover")))
	{
		csntc(nick, "Quelqu'un est dj identifi sur cet username.");
		csntc(user->n, "%s vient de tenter de se loguer sous votre username avec le bon pass. Vous pouvez en changer avec la commande '%s PASS'.", nick->nick, RealCmd("set"));
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \2%s\2 par \2%s\2 (\2Admin %d\2)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d (dj utilis) par %s\n", user->nick, user->level, nick->nick);
		}
		return 0;
	}
	if(IsSuspend(user))
	{
		show_ususpend(nick, user);
		if(IsAnAdmin(user))
		{
			cswall("Failed Login sur \2%s\2 par \2%s\2 (\2Admin %d\2)", user->nick, nick->nick, user->level);
			putlog(LOG_FAUTH, "LOGIN %s NIVEAU %d (suspendu) par %s\n", user->nick, user->level, nick->nick);
		}
		return 0;
	}

#ifdef HAVE_TRACK
	if((track = istrack(user))) csntc(track->tracker, "[\2Track\2] %s de %s (%s!%s@%s)",
		parv[0], user->nick, nick->nick, nick->ident, nick->host);
#endif

#ifdef USE_NICKSERV
	del_killinfo(nick, user->nick); /* arret du kill, vu ke c son nick !*/
#endif

	if(UOubli(user)) DelUOubli(user);
	if(UFirst(user)) DelUFirst(user);
	SetNRegister(nick);
	nick->user = user;
	nick->user->n = nick;
	nick->user->lastseend = time(NULL);

	cs_account(nick, nick->user->nick);

	csntc(nick, "Login \2russi\2 pour %s, vous avez dsormais accs  tous vos salons, mmos et au contrle de votre pseudo", nick->user);
#ifdef SQLLOG
 	sql_query("INSERT INTO usercmdslog (user, TS, cmd, log) VALUES ('%s', UNIX_TIMESTAMP(), '%s', '%s!%s@%s');", nick->user->nick, RealCmd(parv[0]),
 		nick->nick, nick->ident, nick->host);
#endif

	if(IsAnAdmin(nick->user))
	{
		csntc(nick, "\2Vous tes identifi en tant qu'Administrateur niveau %d", nick->user->level);
#ifdef USE_WELCOMESERV
		if(admin_motd[0] != '\0') csntc(nick, "Message du jour Admin :\2 %s", admin_motd);
#endif
	}
#ifdef USE_WELCOMESERV
	else if(user_motd[0] != '\0') csntc(nick, "Message du jour User :\2 %s", user_motd);
#endif
#ifdef HAVE_CRYPTHOST
	if(GetConf(CF_HOSTHIDING) && GetConf(CF_XMODE) && UWantX(user) && !(nick->flag & N_CRYPT)) putserv("%s %s %s :+x\n", cs.num, TOKEN_SVSMODE, nick->numeric);
#endif

#ifdef USE_MEMOSERV
	show_notes(nick);
#endif

#ifdef HAVE_VOTE
	if(vote_actif && vote_nbprop && !user->vote)
	{
		show_vote(nick);
		csntc(nick, "Pour voter tapez \2/%s %s <n de la proposition>\2\37.", cs.nick, RealCmd("voter"));
	}
#endif

	/*auto-autoop propos par BugMaster :)*/
	for(a=nick->user->accesshead;a;a=a->next)
	{
		if(AWait(a)) continue;
		if((j = getjoininfo(nick, a->c->chan))) a->lastseen = 1; /* et non pas time(NULL) car il est sur le salon */

		if(j && (AOp(a) || AVoice(a)) && !ASuspend(a) && a->level >= 50)
		{
			int needop = 0, needvoice = 0;
			if(AOp(a) && !j->is_op && a->level >= 100 && !CNoOps(a->c)) j->is_op = needop = 1;
			if(AVoice(a) && !j->is_voice) j->is_voice = needvoice = 1;
			if(needop || needvoice) csmode(a->c, "+%s%s %s %s", needop ? "o" : "", needvoice ? "v" : "", needop ? nick->numeric : "", needvoice ? nick->numeric : "");
		}
		if(a->c->motd) csntc(nick, "\2 [Message du jour] - %s -\2 %s", a->c->chan, a->c->motd);
		if(!j && CAutoInvite(a->c) && (a->c->mode & (C_MINV | C_MKEY) || (a->c->mode & C_MLIMIT && a->c->users >= a->c->limit)))
			putserv("%s " TOKEN_INVITE " %s :%s\r\n", cs.num, nick->nick, a->c->chan);
	}

	write_anuser(user); /* **joli** oubli qui a cout le deluser a beaucoup.. */
	return 1;
}

#ifdef USE_NICKSERV
int recover(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aNick *who, *whoauth = NULL, *whon = NULL;

	if(!nick->user)
	{
		if(parc < 2) return syntax_cmd(nick, GetCmdIndexbyName("recover"));

		if(!ns_login(nick, chaninfo, parc, parv)) return 0;

		for(who = nickhead;who;who = who->next)
		{
			if(nick != who && who->user == nick->user) whoauth = who;
			if(nick != who && !strcasecmp(who->nick, nick->user->nick)) whon = who;
		}
	}
	else
	{
		char *user = parc ? parv[1] : nick->user->nick;

		if(strcasecmp(nick->user->nick, user))
			return csntc(nick, "Vous tes logu sous l'UserName \2%s\2 et non '%s'", nick->user->nick, user);

		if(!strcasecmp(nick->nick, nick->user->nick))
			return csntc(nick, "Votre nick est dj %s.", nick->nick);

		if(!(whon = getnickbynick(nick->user->nick)))
			return csntc(nick, "Personne n'est actuellement connect avec le pseudo %s, merci d'utiliser la commande /nick",
						nick->user->nick);
	}

	if(whoauth) /* personne authe sur le mme username, deauthons le.*/
	{
		cs_account(whoauth, NULL);
		csntc(whoauth, "%s a utilis recover: \2vous n'tes plus identifi", nick->nick);
	}

	if(whon) /* personne possdant le nick == username */
	{
		if(!UPKill(nick->user))
		{
			char buff[NICKLEN + 1];
			snprintf(buff, NICKLEN, "%s%02d", CHNICKRAND, rand());
			putserv("%s " TOKEN_SVSNICK " %s :%s\n", bot.servnum, whon->numeric, buff);
		}
		else
		{
			putserv("%s " TOKEN_KILL " %s :%s (Pseudo enregistr)\n", cs.num, whon->numeric, cs.nick);
			del_nickinfo(whon);
		}
		csntc(nick, "Le nick \2%s\2 est dsormais disponible.", nick->user->nick);
	}
	return 1;
}
#endif

int myaccess(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char chans[512] = {0}, b[(REGCHANLEN + 20)], chansw[512] = {0};
	int chan = 0, i = 0, size = 0, first = 0, sizew = 0, firstw = 0;
	anAccess *a;

	if(!nick->user) return 0;

	if(parc)
	{
		const char *cmd = parv[1];
		if(!strcasecmp(cmd, "accept"))
		{
			if(parc < 2) return csntc(nick, "Syntaxe: ACCEPT <#salon>");

			if(!(nick->user->flag & U_POKACCESS))
				return csntc(nick, "Vous ne pouvez pas utiliser cette commande: vous %s toutes les "
					"propositions d'accs !", (nick->user->flag & U_PACCEPT) ? "acceptez" : "refusez");

			for(a = nick->user->accesshead;a && strcasecmp(a->chan, parv[2]);a = a->next);

			if(!a || !AWait(a))
				return csntc(nick, "Vous n'avez aucune proposition d'access sur %s", parv[2]);

			csntc(nick, "Vous avez maintenant un access sur %s", a->chan);
			a->flag &= ~A_WAITACCESS;
			write_anuser(nick->user);
			return 1;
		}
		if(!strcasecmp(cmd, "refuse"))
		{
			if(parc < 2) return csntc(nick, "Syntaxe: REFUSE <#salon>");

			if(!(nick->user->flag & U_POKACCESS))
				return csntc(nick, "Vous ne pouvez pas utiliser cette commande: vous %s toutes les propositions d'accs !",
								(nick->user->flag & U_PACCEPT) ? "acceptez" : "refusez");

			for(a = nick->user->accesshead;a && strcasecmp(a->chan, parv[2]);a = a->next);

			if(!a || !AWait(a))
				return csntc(nick, "Vous n'avez aucune proposition d'accs sur %s", parv[2]);

			csntc(nick, "La proposition d'accs pour %s a bien t refuse.", a->chan);
			del_access(nick->user, a->c);
			write_anuser(nick->user);
			return 1;
		}
		if(!strcasecmp(cmd, "drop"))
		{
			if(parc < 2) return csntc(nick, "Syntaxe: DROP <#salon>");

			if(!(a = GetAccessIbyUserI(nick->user, parv[2])))
				return csntc(nick, "Vous n'avez pas d'accs sur %s", parv[2]);

			if(a->level == OWNERLEVEL)
				return csntc(nick, "Vous tes l'owner de %s. Pour supprimer cet accs vous devez desenregistrer le salon.", parv[2]);

			del_access(nick->user, a->c);
			write_anuser(nick->user);
			csntc(nick, "Vous avez bien supprim votre access de %s", parv[2]);
			return 1;
		}
	}

	if(!getoption("-access",parv,parc,1,-1))
	{
		csntc(nick, "Info sur l'Username \2%s", nick->user->nick);
		csntc(nick, " Mail enregistr: %s", nick->user->mail);
		if(IsAnAdmin(nick->user)) csntc(nick, "\2Accs Administrateur\2 (\002%d\2)", nick->user->level);

		for(a = nick->user->accesshead;a;a = a->next)
		{
			int p = snprintf(b, REGCHANLEN + 20, "%s (%d) ", a->chan, a->level);
			if(AWait(a))
			{
				int tmps = sizew;
				sizew += p > 0 ? p : REGCHANLEN + 20;
				if(sizew >= 450) /* le dernier fait depasser le buffer */
				{
					csntc(nick, "%s%s ...", !firstw ? " Vous avez des propositions sur: " : "", chansw);
					strcpy(chansw, b); /* ajoute le suivant pour la prochaine*/
					firstw = 1;
					sizew = strlen(b);
				}
				else strcpy(&chansw[tmps], b);
			}
			else
			{
				int tmps = size;
				size += p > 0 ? p : REGCHANLEN + 20;
				if(size >= 450) /* le dernier fait depasser le buffer */
				{
					csntc(nick, "%s%s ...", !first ? " Vous avez accs : " : "", chans);
					strcpy(chans, b); /* ajoute le suivant pour la prochaine*/
					first = 1;
					size = strlen(b);
				}
				else strcpy(&chans[tmps], b);
			}
		}

		if(chans[0] != '\0') csntc(nick, "%s%s", !first ? " Vous avez accs : " : "", chans);
		else if(!first) csntc(nick, " Vous n'avez aucun accs.");
		if(chansw[0] != '\0') csntc(nick, "%s%s", !firstw ? " Vous avez des propositions sur: " : "", chansw);
		else if(!firstw) csntc(nick, " Vous n'avez aucune proposition d'access.");

#ifdef HAVE_VOTE
		if(vote_actif)
		{
			if(nick->user->vote) csntc(nick, " Vous avez vot pour: \2%s", vote[(nick->user->vote-1)].prop);
			else csntc(nick, " Vous n'avez pas encore vot");
		}
#endif
		csntc(nick, " Options: %s", GetUserOptions(nick->user));
		csntc(nick, " Last Login depuis %s", nick->user->lastlogin ? nick->user->lastlogin : "<Non Disponible>");
		return 1;
	}

	chan = getoption("-chan", parv, parc, 1, 0);
	for(a = nick->user->accesshead;a;a = a->next)
	{
		if(AWait(a) || (chan && match(parv[chan], a->chan))) continue;
		csntc(nick, "%s", a->chan);
		show_accessn(a, nick->user, nick);
		csntc(nick, "-");
		i++;
	}

	return csntc(nick, "Un Total de %d entre%s trouve%s", i, PLUR(i), PLUR(i));
}

int deauth(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
   if(!nick->user) return csntc(nick, "Vous n'tes pas logu.");

   csntc(nick, "Vous venez de vous dloguer de l'UserName \2%s\2", nick->user->nick);
   cs_account(nick, NULL);
   return 1;
}

int user_set(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	const char *arg = parv[1];

	if(!strcasecmp(arg,"mail"))
	{
		anUser *users;
		if(parc < 2)
			return csntc(nick, "Syntaxe: %s MAIL <mail>", RealCmd("set"));

		if(strlen(parv[2]) > MAILLEN)
			return csntc(nick, "Le mail est limit  %d charactres.", MAILLEN);

		if(!IsValidMail(parv[2]))
			return csntc(nick, "Veuillez entrer un email correct.");

		if(!strcasecmp(nick->user->mail, parv[2]))
			return csntc(nick, "%s est dj votre mail enregistr.", parv[2]);

		for(users=userhead;users;users = users->next)
			if(!strcasecmp(users->mail, parv[2])) return csntc(nick, "Ce mail est dj utilis.");

		strcpy(nick->user->mail, parv[2]);
		nick->user->mail[MAILLEN] = 0;
		csntc(nick, "Votre mail a t chang en\2 %s", nick->user->mail);
	}
	else if(!strcasecmp(arg, "virtualhost"))
	{
		if(!GetConf(CF_XMODE))
			return csntc(nick, "La commande VIRTUALHOST est desactive");

		if(parc < 2) ToggleFlag(&nick->user->flag, U_WANTX);
		else if(!strcasecmp(parv[2], "ON")) SetUWantX(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUWantX(nick->user);
		else return csntc(nick, "La valeur doit tre ON ou OFF");

		if(UWantX(nick->user)) csntc(nick, "L'option VIRTUALHOST est ACTIVE: lors de votre "
			"identification, votre host sera automatiquement change en %s.%s", nick->user->nick, HIDDEN_HOST);
		else csntc(nick, "L'option VIRTUALHOST est DESACTIVE.");
	}
#ifdef USE_NICKSERV
	else if(!strcasecmp(arg, "protect"))
	{
		int protect;
		if(parc < 2 || !is_num(parv[2]) || (protect = atoi(parv[2])) < 0 || protect > 2)
		{
			csntc(nick, "Syntaxe: %s PROTECT <0/1/2>", RealCmd("set"));
			csntc(nick, "0 = pas de protection, 1 = changement de pseudo, 2 = kill");
			return 0;
		}
		if(protect == 1)
		{
			SetUPNick(nick->user);
			if(UPKill(nick->user)) DelUPKill(nick->user);
			csntc(nick, "La protection est active: lorsqu'un user prendra votre username comme pseudo, son pseudo sera chang au bout de %d secondes", kill_interval);
		}
		else if(protect == 2)
		{
			SetUPKill(nick->user);
			if(UPNick(nick->user)) DelUPNick(nick->user);
			csntc(nick, "La protection est active: lorsqu'un user prendra votre username comme pseudo, il sera kill au bout de %d secondes", kill_interval);
		}
		else
		{
			if(UPNick(nick->user)) DelUPNick(nick->user);
			if(UPKill(nick->user)) DelUPKill(nick->user);
			csntc(nick, "La protection est desactive");
		}
	}
#endif
#ifdef USE_MEMOSERV
	else if(!strcasecmp(arg, "nomemo"))
	{
		if(parc < 2) ToggleFlag(&nick->user->flag, U_NOMEMO);
		else if(!strcasecmp(parv[2], "ON")) SetUNoMemo(nick->user);
		else if(!strcasecmp(parv[2], "OFF")) DelUNoMemo(nick->user);
		else return csntc(nick, "La valeur doit tre ON ou OFF");

		if(UNoMemo(nick->user))
			csntc(nick, "Le NOMEMO est actif: personne ne pourra vous envoyer de memos (except les admins)");
		else csntc(nick, "Le NOMEMO est inactif: quiconque peut vous envoyer des memos");
	}
#endif
	else if(!strcasecmp(arg,"pass"))
	{
		if(parc < 2)
			return csntc(nick, "Syntaxe: %s PASS <pass>", RealCmd("set"));

		if(strlen(parv[2]) < 6 || strlen(parv[2]) > 15)
			return csntc(nick, "Le pass doit faire entre 6 et 15 caractres.");

		strcpy(nick->user->passwd, mkpass(parv[2]));
		csntc(nick, "\2Votre mot de passe a bien t chang\2");
	}
	else if(!strcasecmp(arg, "username"))
	{
		anUser *u;

		if(parc < 2)
			return csntc(nick, "Syntaxe: %s USERNAME <nouvel username>", RealCmd("set"));

		if(nick->user->flag & U_ALREADYCHANGE)
			return csntc(nick, "Vous avez dj rcemment chang votre UserName.");

		if(strlen(parv[2]) >= NICKLEN)
			return csntc(nick, "La longueur des UserNames est limite  %d.", NICKLEN);

		if(!IsValidNick(parv[2]))
			return csntc(nick, "%s ne peut pas tre enregistr: contient des caractres illgaux", parv[2]);

		if(IsBadNick(parv[2]))
			return csntc(nick, "%s ne peut pas tre enregistr: pseudo illgal.", parv[2]);

		if((u = getuserinfo(parv[2])))
			return csntc(nick, "\2%s\2 est dj un UserName enregistr.", u->nick);

		File_UserDel(nick->user->nick);
		cs_account(nick, parv[2]);
		Strncpy(nick->user->nick, parv[2], NICKLEN);
		nick->user->flag |= U_ALREADYCHANGE;
		csntc(nick, "Votre username a t chang en %s", parv[2]);
		write_userlist();
	}
	else if(!strcasecmp(arg, "access"))
	{
		int i;
		anAccess *a, *at;

		if(parc < 2 || !is_num(parv[2]))
		{
			csntc(nick, "Syntaxe: %s ACCESS <0/1/2>", RealCmd("set"));
			csntc(nick, "Syntaxe: 0 Refuse toute proposition d'accs");
			csntc(nick, "Syntaxe: 1 Requiert la confirmation/refus");
			csntc(nick, "Syntaxe: 2 Accepte toute proposition d'accs");
			return 0;
		}

		switch((i = atoi(parv[2])))
		{
			case 0:
			nick->user->flag &= ~(U_POKACCESS | U_PACCEPT);
			nick->user->flag |= U_PREJECT;
			csntc(nick, "Les propositions d'accs vous concernant seront systmatiquement refuses.");
			for(a = nick->user->accesshead;a;a = at)
			{
				at = a->next;
				if(AWait(a))
				{
					i++;
					del_access(nick->user, a->c);
				}
			}
			if(i) csntc(nick, "Vos %d propositions en cours on t supprimes.", i);
			break;

			case 1:
			nick->user->flag &= ~(U_PACCEPT | U_PREJECT);
			nick->user->flag |= U_POKACCESS;
			csntc(nick, "Vous pourrez dsormais choisir via /%s %s ACCEPT/REFUSE <#salon> que faire d'un accs.", cs.nick, RealCmd("myaccess"));
			break;

			case 2:
			i = 0;
			nick->user->flag &= ~(U_PREJECT | U_POKACCESS);
			nick->user->flag |= U_PACCEPT;
			csntc(nick, "Les propositions d'accs vous concernant seront systmatiquement acceptes.");
			for(a = nick->user->accesshead;a;a = a->next)
				if(AWait(a))
				{
					i++;
					a->flag &= ~A_WAITACCESS;
				}
			if(i) csntc(nick, "Vos %d propositions en cours on t acceptes.", i);
			break;

			default:
			csntc(nick, "L'argument doit tre compris entre 0 et 2.");
			return 1;
		}

	}
	else return csntc(nick, "Option de SET inconnue.");

	write_anuser(nick->user);
	return 1;
}
